import { Injectable, NgModule, Component, Input, ViewChild, ElementRef, defineInjectable } from '@angular/core';
import { MatIconModule } from '@angular/material/icon';
import { MatRippleModule } from '@angular/material/core';
import { MatButtonModule } from '@angular/material/button';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GIXNGButtonsService {
    constructor() { }
    /**
     * @param {?} icon
     * @return {?}
     */
    getEasyNaming(icon) {
        switch (icon) {
            case "profile":
                return "people";

            case "profil": return "people";
            case "login": return "lock";
            case "connect": return "lock";
            case "log-in": return "lock";
            case "logout": return "lock_open";
            case "disconnect": return "lock_open";
            case "log-out": return "lock_open";
            default:
                return icon;
                break;
        }
    }
}
GIXNGButtonsService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
GIXNGButtonsService.ctorParameters = () => [];
/** @nocollapse */ GIXNGButtonsService.ngInjectableDef = defineInjectable({ factory: function GIXNGButtonsService_Factory() { return new GIXNGButtonsService(); }, token: GIXNGButtonsService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GixButtonCornectoComponent {
    /**
     * @param {?} gIXNGButtonsService
     */
    constructor(gIXNGButtonsService) {
        this.gIXNGButtonsService = gIXNGButtonsService;
        //does some mapping of common name
        if (this.icon) {
            this.iconValue = this.gIXNGButtonsService.getEasyNaming(this.icon);
            console.log("Button icon:" + this.icon + '/' + this.iconValue);
        }
        //default value for buttons/icon
        if (!this.txt)
            this.txt = "create";
        if (!this.icon)
            this.icon = "add";
        if (!this.color)
            this.color = "primary";
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
GixButtonCornectoComponent.decorators = [
    { type: Component, args: [{
                selector: 'gix-button-cornecto',
                template: "<!--@STCGoal Goal: Make this button shaped like the Corner rectangle with an Icon + Create a Component for that button type:-->\n\n\n<button mat-raised-button [color]=\"color\"  class=\"gix-button-shadow gix-cornecto-button\">  \n    <mat-icon>{{iconValue}}</mat-icon>  \n     <span class=\"gix-button-cornecto-label\">{{txt}}</span>\n</button>\n\n",
                styles: [".gix-button-shadow{box-shadow:0 3px 5px -1px rgba(0,0,0,.2),0 6px 10px 0 rgba(0,0,0,.14),0 1px 18px 0 rgba(0,0,0,.12);-webkit-box-shadow:0 3px 5px -1px rgba(0,0,0,.2),0 6px 10px 0 rgba(0,0,0,.14),0 1px 18px 0 rgba(0,0,0,.12)}.gix-button-cornecto-label{justify-content:flex-start;text-overflow:ellipsis;white-space:nowrap;overflow:hidden}.gix-cornecto-button{font-family:Roboto,sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-size:.875rem;line-height:2.25rem;font-weight:500;letter-spacing:.0892857143em;text-decoration:none;text-transform:uppercase;border-radius:12px;padding:0 20px;width:auto;max-width:100%;margin-right:24px}"]
            }] }
];
/** @nocollapse */
GixButtonCornectoComponent.ctorParameters = () => [
    { type: GIXNGButtonsService }
];
GixButtonCornectoComponent.propDecorators = {
    txt: [{ type: Input }],
    icon: [{ type: Input }],
    color: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GixButtonTwolcornComponent {
    /**
     * @param {?} gIXNGButtonsService
     */
    constructor(gIXNGButtonsService) {
        this.gIXNGButtonsService = gIXNGButtonsService;
        //does some mapping of common name
        if (this.icon) {
            this.iconValue = this.gIXNGButtonsService.getEasyNaming(this.icon);
        }
        //default value for buttons/icon
        if (!this.txt)
            this.txt = "";
        if (!this.icon)
            this.icon = "add";
        if (!this.color)
            this.color = "primary";
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        /** @type {?} */
        let textFactor = 17;
        if (this.txt) {
            /** @type {?} */
            let newLenght = this.txt.length * textFactor;
            this.gixTwoCornButton.nativeElement.style.width = newLenght + "px";
        }
    }
}
GixButtonTwolcornComponent.decorators = [
    { type: Component, args: [{
                selector: 'gix-button-twolcorn',
                template: "\n    <!--@feature gix-button-twolcorner\n      <h5> A Nice rouded only at two corner and sharp at the other FAB</h5>\n    <h6>CSS CLASS: gix-button-twolcorner</h6>-->\n    \n    <button \n      mat-fab [color]=\"color\" class=\"gix-button-twolcorn\" #gixTwoCornButton>\n        <mat-icon>{{iconValue}}</mat-icon>\n        <span class=\"tstlabelclass\" #gitTwoCornButtonLabel>{{txt}}</span>\n      </button>",
                styles: [".gix-button-twolcorn{border-radius:50% 0}.gix-button-shadow{box-shadow:0 3px 5px -1px rgba(0,0,0,.2),0 6px 10px 0 rgba(0,0,0,.14),0 1px 18px 0 rgba(0,0,0,.12);-webkit-box-shadow:0 3px 5px -1px rgba(0,0,0,.2),0 6px 10px 0 rgba(0,0,0,.14),0 1px 18px 0 rgba(0,0,0,.12)}"]
            }] }
];
/** @nocollapse */
GixButtonTwolcornComponent.ctorParameters = () => [
    { type: GIXNGButtonsService }
];
GixButtonTwolcornComponent.propDecorators = {
    gixTwoCornButton: [{ type: ViewChild, args: ["gixTwoCornButton", { read: ElementRef },] }],
    gitTwoCornButtonLabel: [{ type: ViewChild, args: ["gitTwoCornButtonLabel", { read: ElementRef },] }],
    txt: [{ type: Input }],
    icon: [{ type: Input }],
    color: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GIXNGButtonsModule {
}
GIXNGButtonsModule.decorators = [
    { type: NgModule, args: [{
                declarations: [GixButtonCornectoComponent, GixButtonTwolcornComponent],
                imports: [
                    MatIconModule,
                    MatRippleModule,
                    MatButtonModule
                ],
                exports: [GixButtonCornectoComponent, GixButtonTwolcornComponent, MatButtonModule]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { GIXNGButtonsService, GixButtonCornectoComponent, GixButtonTwolcornComponent, GIXNGButtonsModule };

//# sourceMappingURL=gixngbuttons.js.map